/*

PanelServices

wb_[		lwpanel.h

*/

#include "main.h"
#include <lwpanel.h>

static LWPanControlDesc		desc;	 // required by macros in lwpanel.h
static LWValue				ival={LWT_INTEGER};
static LWValue				ivecval={LWT_VINT};		// required by macros in lwpanel.h
static LWValue				fval={LWT_FLOAT};
static LWValue				fvecval={LWT_VFLOAT};
static LWValue				sval={LWT_STRING};

static GlobalFunc	*g_global = NULL;

void refreshSettings(MyData *data);


XCALL_(LWError) Options(LWInstance inst)
{
	MyData			*data = (MyData*)inst;
	LWPanelFuncs	*panel = (LWPanelFuncs*)g_global(LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT);
	LWPanelID		pid = NULL;
	int				result = 0;
	LWControl		*ctl[3];
	int				temp;

	if( !panel )
		return "";

	if( pid = PAN_CREATE(panel, SERVERNAME) ){
		ctl[0] = ITEM_CTL(panel, pid, "Q", data->global, LWI_BONE);
		ctl[1] = BOOL_CTL(panel, pid, "̐ςێ");
		ctl[2] = BOOL_CTL(panel, pid, "After IK");

		temp = (int)*data->reference;
		SET_INT(ctl[0], temp);
		temp = data->holdVolume ? 1 : 0;
		SET_INT(ctl[1], temp);
		temp = data->afterIK ? 1 : 0;
		SET_INT(ctl[2], temp);

		if( PAN_POST(panel, pid) ){
			result = 1;
			GET_INT(ctl[0], temp);
			*data->reference = (LWItemID)temp;
			GET_INT(ctl[1], temp);
			data->holdVolume = temp ? true : false;
			GET_INT(ctl[2], temp);
			data->afterIK = temp ? true : false;
			refreshSettings(data);
		}
		PAN_KILL(panel, pid);
	}

	return NULL;
}



XCALL_(int)Interface(long version, GlobalFunc *global, LWInterface *local, void *serverData)
{
	if( version != LWINTERFACE_VERSION )
		return AFUNC_BADVERSION;

	g_global = global;

	local->panel	= NULL;
	local->options	= Options;
	local->command	= NULL;

	return AFUNC_OK;
}




