#include "LW_CMatrix.h"

LW_CMatrix_4x4::LW_CMatrix_4x4()
{
	m_matrix[0][0] = 1.0;	m_matrix[0][1] = 0.0;	m_matrix[0][2] = 0.0;	m_matrix[0][3] = 0.0;	
	m_matrix[1][0] = 0.0;	m_matrix[1][1] = 1.0;	m_matrix[1][2] = 0.0;	m_matrix[1][3] = 0.0;	
	m_matrix[2][0] = 0.0;	m_matrix[2][1] = 0.0;	m_matrix[2][2] = 1.0;	m_matrix[2][3] = 0.0;	
	m_matrix[3][0] = 0.0;	m_matrix[3][1] = 0.0;	m_matrix[3][2] = 0.0;	m_matrix[3][3] = 1.0;	
}

LW_CMatrix_4x4::~LW_CMatrix_4x4()
{
}

void LW_CMatrix_4x4::init()
{
	m_matrix[0][0] = 1.0;	m_matrix[0][1] = 0.0;	m_matrix[0][2] = 0.0;	m_matrix[0][3] = 0.0;	
	m_matrix[1][0] = 0.0;	m_matrix[1][1] = 1.0;	m_matrix[1][2] = 0.0;	m_matrix[1][3] = 0.0;	
	m_matrix[2][0] = 0.0;	m_matrix[2][1] = 0.0;	m_matrix[2][2] = 1.0;	m_matrix[2][3] = 0.0;	
	m_matrix[3][0] = 0.0;	m_matrix[3][1] = 0.0;	m_matrix[3][2] = 0.0;	m_matrix[3][3] = 1.0;	
}

void LW_CMatrix_4x4::translate(double x, double y, double z)
{
	m_matrix[0][0] = m_matrix[0][0] + m_matrix[0][3] * x;
	m_matrix[0][1] = m_matrix[0][1] + m_matrix[0][3] * y;
	m_matrix[0][2] = m_matrix[0][2] + m_matrix[0][3] * z;
	m_matrix[1][0] = m_matrix[1][0] + m_matrix[1][3] * x;
	m_matrix[1][1] = m_matrix[1][1] + m_matrix[1][3] * y;
	m_matrix[1][2] = m_matrix[1][2] + m_matrix[1][3] * z;
	m_matrix[2][0] = m_matrix[2][0] + m_matrix[2][3] * x;
	m_matrix[2][1] = m_matrix[2][1] + m_matrix[2][3] * y;
	m_matrix[2][2] = m_matrix[2][2] + m_matrix[2][3] * z;
	m_matrix[3][0] = m_matrix[3][0] + m_matrix[3][3] * x;
	m_matrix[3][1] = m_matrix[3][1] + m_matrix[3][3] * y;
	m_matrix[3][2] = m_matrix[3][2] + m_matrix[3][3] * z;
}
void LW_CMatrix_4x4::rotateX(double x)
{
	double	s = sin(x);
	double	c = cos(x);
	double	m[4][4];
	int		i, j;

	for(i=0; i<4; i++){
		for(j=0; j<4; j++){
			m[i][j] = m_matrix[i][j];
		}
	}

	m_matrix[0][1] = m[0][1]*c - m[0][2]*s;
	m_matrix[0][2] = m[0][1]*s + m[0][2]*c;
	m_matrix[1][1] = m[1][1]*c - m[1][2]*s;
	m_matrix[1][2] = m[1][1]*s + m[1][2]*c;
	m_matrix[2][1] = m[2][1]*c - m[2][2]*s;
	m_matrix[2][2] = m[2][1]*s + m[2][2]*c;
	m_matrix[3][1] = m[3][1]*c - m[3][2]*s;
	m_matrix[3][2] = m[3][1]*s + m[3][2]*c;
}
void LW_CMatrix_4x4::rotateY(double y)
{
	double	s = sin(y);
	double	c = cos(y);
	double	m[4][4];
	int		i, j;

	for(i=0; i<4; i++){
		for(j=0; j<4; j++){
			m[i][j] = m_matrix[i][j];
		}
	}

	m_matrix[0][0] = m[0][0]*c + m[0][2]*s;
	m_matrix[0][2] = -m[0][0]*s + m[0][2]*c;
	m_matrix[1][0] = m[1][0]*c + m[1][2]*s;
	m_matrix[1][2] = -m[1][0]*s + m[1][2]*c;
	m_matrix[2][0] = m[2][0]*c + m[2][2]*s;
	m_matrix[2][2] = -m[2][0]*s + m[2][2]*c;
	m_matrix[3][0] = m[3][0]*c + m[3][2]*s;
	m_matrix[3][2] = -m[3][0]*s + m[3][2]*c;
}

void LW_CMatrix_4x4::rotateZ(double z)
{
	double	s = sin(z);
	double	c = cos(z);
	double	m[4][4];
	int		i, j;

	for(i=0; i<4; i++){
		for(j=0; j<4; j++){
			m[i][j] = m_matrix[i][j];
		}
	}

	m_matrix[0][0] = m[0][0]*c - m[0][1]*s;
	m_matrix[0][1] = m[0][0]*s + m[0][1]*c;
	m_matrix[1][0] = m[1][0]*c - m[1][1]*s;
	m_matrix[1][1] = m[1][0]*s + m[1][1]*c;
	m_matrix[2][0] = m[2][0]*c - m[2][1]*s;
	m_matrix[2][1] = m[2][0]*s + m[2][1]*c;
	m_matrix[3][0] = m[3][0]*c - m[3][1]*s;
	m_matrix[3][1] = m[3][0]*s + m[3][1]*c;
}

void LW_CMatrix_4x4::rotateHPB(double h, double p, double b)
{
	rotateZ(b);
	rotateX(p);
	rotateY(h);
}

void LW_CMatrix_4x4::scale(double x, double y, double z)
{
	m_matrix[0][0] = m_matrix[0][0] * x;
	m_matrix[0][1] = m_matrix[0][1] * y;
	m_matrix[0][2] = m_matrix[0][2] * z;
	m_matrix[1][0] = m_matrix[1][0] * x;
	m_matrix[1][1] = m_matrix[1][1] * y;
	m_matrix[1][2] = m_matrix[1][2] * z;
	m_matrix[2][0] = m_matrix[2][0] * x;
	m_matrix[2][1] = m_matrix[2][1] * y;
	m_matrix[2][2] = m_matrix[2][2] * z;
	m_matrix[3][0] = m_matrix[3][0] * x;
	m_matrix[3][1] = m_matrix[3][1] * y;
	m_matrix[3][2] = m_matrix[3][2] * z;
}

void LW_CMatrix_4x4::Transform(LWDVector pos)
{
	LWDVector	temp = { pos[0], pos[1], pos[2] };

	pos[0] = temp[0]*m_matrix[0][0] + temp[1]*m_matrix[1][0] + temp[2]*m_matrix[2][0] + m_matrix[3][0];
	pos[1] = temp[0]*m_matrix[0][1] + temp[1]*m_matrix[1][1] + temp[2]*m_matrix[2][1] + m_matrix[3][1];
	pos[2] = temp[0]*m_matrix[0][2] + temp[1]*m_matrix[1][2] + temp[2]*m_matrix[2][2] + m_matrix[3][2];
}

void LW_CMatrix_4x4::Transform(LWFVector pos)
{
	LWDVector	dpos = { pos[0], pos[1], pos[2] };
	int			i;

	Transform(dpos);
	for(i=0; i<3; i++)
		pos[i] = (float)dpos[i];
}

LW_CMatrix_4x4 LW_CMatrix_4x4::operator*(const LW_CMatrix_4x4 &mat44)
{
	LW_CMatrix_4x4	mat;

	for(int i=0; i<4; i++){
		for(int j=0; j<4; j++){
			mat.m_matrix[i][j] =	m_matrix[i][0]*mat44.m_matrix[0][j] + 
									m_matrix[i][1]*mat44.m_matrix[1][j] + 
									m_matrix[i][2]*mat44.m_matrix[2][j] + 
									m_matrix[i][3]*mat44.m_matrix[3][j];
		}
	}

	return mat;
}

LW_CMatrix_4x4 & LW_CMatrix_4x4::operator=(const LW_CMatrix_4x4 &mat44)
{
	for(int i=0; i<4; i++)
		for(int j=0; j<4; j++)
			m_matrix[i][j] = mat44.m_matrix[i][j];

	return *this;
}

