/*

LayoutGeneric

L  LightWave? 6.0
R|[lg  CAEg
wb_[  lwgeneric.h

LWLAYOUTGENERIC_CLASS
LWLAYOUTGENERIC_VERSION

#include <lwgeneric.h>
*/

#include "main.h"


int			RM_getMuscle(void *scanData, LWPolID pol);
LWItemID	getIDbyName(LWItemInfo *iteminfo, const char *name, LWItemType type, LWItemID obj);



//	uItemColorvR}hŎgJ[̃Xg
static const char *g_colorList[] = {
	"Black", "DkBlue", "DkGrn", "DkCyan", "DkRed",
	"Purple", "Brown", "Gray", "Blue", "Green",
	"Cyan", "Red", "Magen", "Orang", "White",
	NULL
};
//	J[J[CfbNXԂ
int getColorIndex(const char *color)
{
	if( !color ) return -1;
	for(int i=0; g_colorList[i];i++){
		if( 0 == strcmp(g_colorList[i], color) ) return i;
	}
	return -1;
}




/***********************************
	ReadMuscle
	XPS̃^OƂ
	EZMuscle{[ɓKp
************************************/
XCALL_(int)ReadMuscleActivate(long version, GlobalFunc *global, LWLayoutGeneric *local, void *serverData)
{
	if( LWLAYOUTGENERIC_VERSION != version )
		return AFUNC_BADVERSION;

	ReadMuscleData	data;
	LWObjectInfo	*objinfo = (LWObjectInfo*)global(LWOBJECTINFO_GLOBAL, GFUSE_TRANSIENT);
	LWInterfaceInfo	*intinfo = (LWInterfaceInfo*)global( LWINTERFACEINFO_GLOBAL, GFUSE_TRANSIENT );
	LWItemInfo		*iteminfo = (LWItemInfo*)global( LWITEMINFO_GLOBAL, GFUSE_TRANSIENT );
	LWGlobalPool	*memfunc = (LWGlobalPool*)global( LWGLOBALPOOL_GLOBAL, GFUSE_TRANSIENT );
	LWMessageFuncs	*msgf = (LWMessageFuncs*)global( LWMESSAGEFUNCS_GLOBAL, GFUSE_TRANSIENT );

	if( !objinfo || !intinfo || !iteminfo || !memfunc || !msgf )
		return AFUNC_BADGLOBAL;

	LWItemID	curObj = intinfo->selItems[0];
	if( LWI_OBJECT != iteminfo->type(curObj) ){
		msgf->error("IuWFNgIĂsĂB", NULL);
		return AFUNC_OK;
	}

	data.global = global;
	data.mesh = objinfo->meshInfo(curObj, 0);

	EZMuscleGlobal	*muscleGlobal = getMuscleGlobal(memfunc);
	MuscleParam		param;
	char			cmd[128];
	std::vector<LWItemID>	idList;

	param.items[2] = NULL;
	memset(param.refPos, 0, sizeof(double)*3);
	param.refresh = true;

	data.mesh->scanPolys(data.mesh, (LWPolScanFunc *)RM_getMuscle, &data);
	//O[o[EZMuscle̐ݒۑ
	for(int i=0; i<data.skels.size(); i++){
		param.items[0] = getIDbyName(iteminfo, data.skels[i].name, LWI_BONE, curObj);
		if( param.items[0] ){
			param.items[1] = getIDbyName(iteminfo, data.skels[i].tipParent, LWI_BONE, curObj);
			param.holdVolume = data.skels[i].holdVol;
			param.afterIK = data.skels[i].afterIK;
			int index = getMuscleGlobalIndex(muscleGlobal, param.items[0]);
			if( -1 == index ){
				muscleGlobal->params.push_back(param);
			}else{
				muscleGlobal->params[index].items[1] = param.items[1];
				muscleGlobal->params[index].holdVolume = param.holdVolume;
				muscleGlobal->params[index].afterIK = param.afterIK;
			}
			sprintf(cmd, "SelectItem %X", param.items[0]);
			local->evaluate(local->data, cmd);
			if( -1 != data.skels[i].color ){
				sprintf(cmd, "ItemColor %d", data.skels[i].color);
				local->evaluate(local->data, cmd);
			}
			idList.push_back(param.items[0]);
		}
	}
	//vectorɃf[^ǉƁACe[^̂
	//Ce[^̍Đݒ̂߂ɃtbVtO𗧂ĂĂ
	for(i=0; i<muscleGlobal->params.size(); i++){
		muscleGlobal->params[i].refresh = true;
	}
	//EZMuscleKp
	//O[o[ɐݒۑĂ̂
	//Kpꂽ{[͎Iɐݒǂݍ
	//Create֐ŃO[o[𒲂ׂĂ
	for(i=0; i<idList.size(); i++){
		sprintf(cmd, "SelectItem %X", idList[i]);
		local->evaluate(local->data, cmd);
		sprintf(cmd, "ApplyServer %s %s", LWITEMMOTION_HCLASS, SN_EZMUSCLE);
		local->evaluate(local->data, cmd);
	}

	return AFUNC_OK;
}

//	|SXLăXPS̃^O
//	EZMusclȅ擾
int RM_getMuscle (void *scanData, LWPolID pol)
{
	ReadMuscleData	*data = (ReadMuscleData*)scanData;
	const char		*ptag;
	unsigned int	flags;
	ReadMuscleParam	param;
	
	if( LWPOLTYPE_BONE == data->mesh->polType(data->mesh, pol) ){
		ptag = data->mesh->polTag(data->mesh, pol, LWPTAG_MSLFLAG);
		if( ptag ){
			flags = (unsigned int)(atoi(ptag));
			param.name = data->mesh->polTag(data->mesh, pol, LWPTAG_PART);
			param.holdVol = flags & 1;
			param.afterIK = (flags>>1) & 1;
			param.tipParent = data->mesh->polTag(data->mesh, pol, LWPTAG_MSLTIP);
			ptag = data->mesh->polTag(data->mesh, pol, LWPTAG_COLOR);
			param.color = getColorIndex(ptag);
			data->skels.push_back(param);
		}
	}
	return 0;
}

//	ACehcԂ
LWItemID getIDbyName(LWItemInfo *iteminfo, const char *name, LWItemType type, LWItemID obj)
{
	if( !name ) return NULL;
	for( LWItemID id=iteminfo->first(type, obj); id; id=iteminfo->next(id) ){
		if( 0 == strcmp(name, iteminfo->name(id)) ) return id;
	}
	return NULL;
}

